"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertSchemaComponent = void 0;
var convertSchemaComponent = function (fields, components, containers, container) {
    if (Array.isArray(fields)) {
        fields.forEach(function (field) { return (0, exports.convertSchemaComponent)(field, components, containers, container); });
    }
    else {
        containers[container].children.push(fields.name);
        components[fields.name] = fields;
        if (fields.component === 'sub-form') {
            if (!containers[fields.name]) {
                containers[fields.name] = {
                    children: []
                };
            }
            fields.fields.forEach(function (subField) { return (0, exports.convertSchemaComponent)(subField, components, containers, fields.name); });
        }
    }
};
exports.convertSchemaComponent = convertSchemaComponent;
var convertSchema = function (schema) {
    var components = {};
    var containers = {
        root: {
            children: [],
            ref: null
        }
    };
    if (schema) {
        (0, exports.convertSchemaComponent)(schema.fields, components, containers, 'root');
    }
    return { components: components, containers: containers };
};
exports.default = convertSchema;
//# sourceMappingURL=convert-schema.js.map