var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { dragDrop, dragStart, updateComponent, updateContainer } from '@data-driven-forms/dnd/reducer';
var reducer = function (state, action) {
    console.log(action.type, '>>', state, action);
    switch (action.type) {
        case 'DRAG_START':
            return dragStart(state, action);
        case 'DRAG_DROP':
            return dragDrop(state, action);
        case 'UPDATE_CONTAINER':
            return updateContainer(state, action);
        case 'UPDATE_COMPONENT':
            return updateComponent(state, action);
        case 'SELECT_COMPONENT':
            state.selectedComponent = action.id;
            return __assign({}, state);
        case 'UNSELECT_COMPONENT':
            state.selectedComponent = null;
            return __assign({}, state);
        case 'UPDATE_PROPS':
            state.components[action.id] = __assign(__assign({}, action.props), { ref: state.components[action.id].ref });
            return __assign({}, state);
        case 'REMOVE_COMPONENT':
            var removeInnerChild_1 = function (id) {
                delete state.components[id];
                if (state.containers[id]) {
                    var children = state.containers[id].children;
                    children.forEach(removeInnerChild_1);
                    delete state.containers[id];
                }
            };
            // remove item + container + all children
            removeInnerChild_1(action.id);
            // clear component from parent container
            var parent_1 = Object.keys(state.containers).find(function (key) {
                return state.containers[key].children.includes(action.id);
            });
            state.containers[parent_1].children = state.containers[parent_1].children.filter(function (key) { return key !== action.id; });
            return __assign(__assign({}, state), (action.id === state.selectedComponent && { selectedComponent: null }));
        case 'TOGGLE_SCHEMA':
            state.showSchema = action.showSchema || !state.showSchema;
            return __assign({}, state);
        case 'SET_MODE':
            state.mode = action.mode;
            return __assign({}, state);
    }
};
export default reducer;
//# sourceMappingURL=reducer.js.map